﻿using System;
using System.Timers;
using HAServer.Interfaces.Core;

namespace HAServer.Components {
	public class Time: IComponent {
		private readonly IMessageBus _messageBus;
		private readonly Timer _timer;

		public Time(IMessageBus messageBus) {
			_messageBus = messageBus;
			_timer = new Timer(1000);
			_timer.Elapsed += TimerElapsed;
		}

		private void TimerElapsed(object sender, ElapsedEventArgs e) {
			_messageBus.PublishMessage("time", DateTime.Now.ToTimeString(), null);
		}

		public void Initialise() {
			_timer.Start();
		}

		public void Shutdown() {
			_timer.Stop();
		}
	}
}
