﻿using HAServer.Interfaces.Core;

namespace HAServer.InfluxDB {
	public static class SettingsProviderInfluxDBExtensions {
		public static string Host(this ISettingsProvider provider) {
			return provider.GetValue("influxHost");
		}

		public static int Port(this ISettingsProvider provider) {
			return int.Parse(provider.GetValue("influxPort", "8086"));
		}

		public static string Database(this ISettingsProvider provider) {
			return provider.GetValue("influxDatabase");
		}

		public static string Measurement(this ISettingsProvider provider) {
			return provider.GetValue("influxMeasurement");
		}

		public static string Username(this ISettingsProvider provider) {
			return provider.GetValue("influxUsername", string.Empty);
		}

		public static string Password(this ISettingsProvider provider) {
			return provider.GetValue("influxPassword", string.Empty);
		}

		public static string Topic(this ISettingsProvider provider) {
			return provider.GetValue("influxTopic", ".*");
		}
	}
}
