﻿using System.IO;
using System.Linq;
using FluentAssertions;
using HAServer.Core;
using HAServer.Interfaces.Core;
using NSubstitute;
using Xunit;

namespace HAServer.Tests.Core {
	public class ComponentLoaderTests {
		private interface ITestInterface { }
		public class TestInterface:ITestInterface { }

		[Fact]
		public void Load_FindsTypes() {
			var dependencies = Substitute.For<IDependencyResolver>();
			dependencies.CreateInstance(typeof(TestInterface)).Returns(new TestInterface());
			var loader = new ComponentLoader<ITestInterface>(Path.Combine(Useful.GetTestDirectory(), "."), dependencies);
			loader.Load();
			loader.Components.First().Should().BeOfType<TestInterface>();
		}
	}
}
