﻿using FluentAssertions;
using HAServer.Core;
using HAServer.Interfaces.Core;
using HAServer.Tests.Stubs;
using NSubstitute;
using Xunit;

namespace HAServer.Tests.Core {
	public class DeviceConditionTests {

		[Fact]
		public void WhenConditionIsEqual_WithTopic_ReturnTrue() {
			var bus = Substitute.For<IMessageBus>();
			var device = new DeviceStub(bus, "test", "Test") {
				Value = "21"
			};
			var condition = new DeviceCondition(Comparator.Equal, "", device);
			condition.IsTrue("21").Should().BeTrue();
		}
	}
}
