using System.Collections;
using System.Collections.Generic;
using System.Linq;

namespace HAServer.Core {
	public class DeviceGroupCollection : IEnumerable<DeviceGroup> {
		private readonly List<DeviceGroup> _groups=new List<DeviceGroup>();

		public DeviceGroup this[string name] {
			get {
				return _groups.First(group => group.Name == name);
			}
		}
		
		public void Add(DeviceGroup group) {
			_groups.Add(group);
		}

		public void Remove(DeviceGroup group) {
			_groups.Remove(group);
		}

		public IEnumerator<DeviceGroup> GetEnumerator() {
			return _groups.GetEnumerator();
		}

		IEnumerator IEnumerable.GetEnumerator() {
			return GetEnumerator();
		}
	}
}