﻿using System.Diagnostics.CodeAnalysis;
using System.IO;
using System.Net;
using HAServer.Interfaces.Core;

namespace HAServer.Core {
	[ExcludeFromCodeCoverage]
	public class HttpGet : IFileGet {
		public string Get(string url) {
			var request = (HttpWebRequest)WebRequest.Create(url);
			using (var response = (HttpWebResponse)request.GetResponse())
			using (var stream = response.GetResponseStream())
			using (var reader = new StreamReader(stream))
				return reader.ReadToEnd();
		}
	}
}
