﻿using System;
using System.IO;
using HAServer.Interfaces.Core;

namespace HAServer.Core {
	public class Log : ILogProvider {
		public LogLevel ConsoleLogLevel { get; }
		public LogLevel FileLogLevel { get; }
		public string FileLocation { get; }

		public Log(string logFileLocation, LogLevel fileLogLevel, LogLevel consoleLogLevel) {
			FileLocation = logFileLocation;
			FileLogLevel = fileLogLevel;
			ConsoleLogLevel = consoleLogLevel;
		}

		public void Write(string message, LogLevel logLevel) {
			var text = $"{logLevel} - {DateTime.Now} - {message}";

			if (logLevel <= ConsoleLogLevel) {
				Console.WriteLine(text);
			}
			if (logLevel <= FileLogLevel) {
				File.AppendAllText(FileLocation, text + Environment.NewLine);
			}
		}
	}
}
