﻿using HAServer.Interfaces.Core;

namespace HAServer.Devices {
	public class Switch : BaseDevice {

		public Switch(IMessageBus messageBus, string topic, string name, string onValue, string offValue):base(messageBus, topic, name) {
			OnValue = onValue;
			OffValue = offValue;
		}

		public string OnValue { get; }
		public string OffValue { get; }

		public bool On {
			get {
				return Value == OnValue;
			}
			set {
				Value = value ? OnValue : OffValue;
				MessageBus.PublishMessage(Topic, Value, this);
			}
		}

		public void TurnOn() {
			On = true;
		}

		public void TurnOff() {
			On = false;
		}
	}
}
