﻿using System;
using HAServer.Core;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

namespace HAServer.Serialisation {
	public class ConditionJsonConverter:JsonConverter<Condition> {
		private readonly DeviceConfig _deviceConfig;

		public ConditionJsonConverter(DeviceConfig deviceConfig) {
			_deviceConfig = deviceConfig;
		}

		public override void WriteJson(JsonWriter writer, object value, JsonSerializer serializer) {
			throw new NotImplementedException();
		}

		public override bool CanWrite => false;

		public override object ReadJson(JsonReader reader, Type objectType, object existingValue, JsonSerializer serializer) {
			var jsonObject = JObject.Load(reader);
			var comparator = jsonObject["Comparator"].ToObject<Comparator>();
			var topic = jsonObject["Topic"].ToObject<string>();

			if (jsonObject["Value"]!=null)
				return new Condition(comparator, topic, jsonObject["Value"].ToString());

			var device = _deviceConfig.Devices[jsonObject["Device"].ToString()];
			return new DeviceCondition(comparator, topic, device);
		}
	}
}
