﻿using System;
using HAServer.Core;
using Newtonsoft.Json;

namespace HAServer.Serialisation {
	public class DeviceGroupJsonConverter : JsonConverter<DeviceGroup> {
		protected override void WriteJson(JsonWriter writer, DeviceGroup group, JsonSerializer serializer) {
			writer.WritePropertyName(group.Name);
			writer.WriteStartArray();
			foreach (var device in group) {
				serializer.Serialize(writer, device.Topic);
			}
			writer.WriteEndArray();
		}

		public override object ReadJson(JsonReader reader, Type objectType, object existingValue, JsonSerializer serializer) {
			throw new NotImplementedException();
		}

		public override bool CanRead => false;
	}
}