﻿using System;
using Newtonsoft.Json;

namespace HAServer.Serialisation {
	public abstract class JsonConverter<T> : JsonConverter {
		public override bool CanConvert(Type objectType) {
			return objectType == typeof(T);
		}

		public override void WriteJson(JsonWriter writer, object value, JsonSerializer serializer) {
			WriteJson(writer, (T)value, serializer);
		}

		protected virtual void WriteJson(JsonWriter writer, T value, JsonSerializer serializer) { }
	}
}
