﻿using HAServer.Core;
using HAServer.Interfaces.Core;
using Newtonsoft.Json;

namespace HAServer.Serialisation {
	public class JsonSerialiserSettings:JsonSerializerSettings {
		public JsonSerialiserSettings(IMessageBus messageBus, DeviceConfig deviceConfig, ILogProvider logProvider) {
			Converters.Add(new BaseDeviceJsonConverter(messageBus));
			Converters.Add(new DeviceGroupCollectionJsonConverter());
			Converters.Add(new DeviceGroupJsonConverter());
			Converters.Add(new TriggerJsonConverter(messageBus, logProvider));
			Converters.Add(new ConditionJsonConverter(deviceConfig));
			Converters.Add(new TriggerActionJsonConverter(deviceConfig));
		}
	}
}
