﻿using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;
using System.Linq;
using HAServer.Core;

namespace HAServer.WebServer.DTO {
	[ExcludeFromCodeCoverage]
	public class TriggerDto {
		public TriggerDto(Trigger trigger) {
			Id = trigger.Id;
			Name = trigger.Name;
			TriggerType = trigger.TriggerType;
			Conditions = trigger.Conditions.Select(condition => new ConditionDto(condition));
			Enabled = trigger.Enabled;
			Actions = trigger.Actions;
		}


		public int Id { get; }
		public string Name { get; }
		public TriggerType TriggerType { get; }
		public IEnumerable<ConditionDto> Conditions { get; }
		public bool Enabled { get; }
		public IEnumerable<TriggerAction> Actions { get; }
	}
}
