﻿using System;
using System.IO;
using System.Text;
using MimeTypes;
using WebSocketSharp.Server;

namespace HAServer.WebServer.RequestHandlers {
	public class DefaultWebRequestHandler : IWebRequestHandler {
		private readonly string _basePath;

		public DefaultWebRequestHandler(string basePath) {
			_basePath = basePath;
		}

		public byte[] GetContent(HttpRequestEventArgs e) {
			var path = e.Request.Url.AbsolutePath;

			if (path.EndsWith("/", StringComparison.Ordinal))
				path += "index.html";

			var filePath = _basePath + path;
			if (File.Exists(filePath)) {
				e.Response.ContentType = MimeTypeMap.GetMimeType(Path.GetExtension(filePath));
				return File.ReadAllBytes(filePath);
			}

			return Encoding.UTF8.GetBytes("not implemented");
		}
	}
}