﻿using System.IO;
using WebSocketSharp.Server;

namespace HAServer.WebServer.RequestHandlers {
	public class WebObjectHandler : IWebRequestHandler {
		private readonly string _basePath;
		public const string ObjectFolder = "Objects";

		public WebObjectHandler(string basePath) {
			_basePath = basePath;
		}

		public void SaveObject(string filename, string data) {
			var realObjectFolder = $"{_basePath}/{ObjectFolder}";
			if (!Directory.Exists(realObjectFolder))
				Directory.CreateDirectory(realObjectFolder);
			File.WriteAllText($"{realObjectFolder}/{filename}", data);
		}

		public byte[] GetContent(HttpRequestEventArgs e) {
			var filePath = _basePath + e.Request.Url.AbsolutePath;
			if (File.Exists(filePath))
				return File.ReadAllBytes(filePath);

			throw new FileNotFoundException(e.Request.Url.LocalPath);
		}
	}
}