﻿app.controller("app", ["$scope", "webApiService", "deviceService", "settingsService", function ($scope, webApiService) {
	$scope.pageTitle = "Home Automation";
	$scope.showMenu = false;
	$scope.showError = false;
	$scope.showLoader = true;

	$scope.setTitle = function (title) {
		$scope.pageTitle = title;
	};

	$scope.toggleMenu = function () {
		$scope.showMenu = !$scope.showMenu;
	};

	$scope.hideMenu = function () {
		$scope.showMenu = false;
	};

	Object.defineProperty($scope, "showOverlay", {
		get: function () {
			return $scope.showMenu || $scope.showError || $scope.showLoader;
		}
	});

	function refreshScope() {
		$scope.$apply();
	}

	function handleSocketClose(event) {
		if (!event.wasClean) {
			$scope.showError = true;
		}
	}

	function webApiCallback(event) {
		switch (event.type) {
			case WebApiCallbackEventType.Open:
				$scope.showError = false;
				break;
			case WebApiCallbackEventType.Message:
				$scope.showLoader = false;
				break;
			case WebApiCallbackEventType.Close:
				handleSocketClose(event.data);
				break;
		}
		refreshScope();
	}

	webApiService.registerMesssageCallback(webApiCallback);

	$scope.$on("$routeChangeStart", function (event) {
		$scope.showLoader = true;
	});
	$scope.$on("$routeChangeSuccess", function (event) {
		$scope.showLoader = false;
	});
	$scope.$on("$routeChangeError", function (event) {
		$scope.showError = true;
		$scope.showLoader = false;
	});
}]);