﻿app.controller("devices", ["$scope", "deviceService", function ($scope, deviceService) {
	$scope.setTitle("Devices");
	$scope.groups = deviceService.groups;
	$scope.devices = deviceService.devices;

	function resetDevice() {
		$scope.newDevice = {
			Name: "",
			Topic: "",
			Type: "",
			OnValue: "",
			OffValue: "",
			Unit: ""
		};
	}

	function resetGroupName() {
		$scope.newGroupName = "";
	}

	function resetNewDeviceGroup() {
		var selectedGroup = ($scope.newDeviceGroup || { GroupName: "" }).GroupName;
		$scope.newDeviceGroup = {
			Device: null,
			GroupName: selectedGroup
		};
	}

	$scope.addDevice = function (newDevice) {
		deviceService.AddDevice(newDevice);
		resetDevice();
	};

	$scope.deleteDevice = function (device) {
		if (confirm("Are you sure you want to delete " + device.Name))
			deviceService.DeleteDevice(device);
	};

	$scope.addGroup = function (groupName) {
		deviceService.AddGroup(groupName);
		resetGroupName();
	};

	$scope.moveGroupUp = function (groupName) {
		deviceService.MoveGroupUp(groupName);
	};

	$scope.moveGroupDown = function (groupName) {
		deviceService.MoveGroupDown(groupName);
	};

	$scope.deleteGroup = function (groupName) {
		if (confirm("Are you sure you want to delete " + groupName))
			deviceService.DeleteGroup(groupName);
	};

	$scope.addDeviceToGroup = function (newDeviceGroup) {
		deviceService.AddDeviceToGroup(newDeviceGroup.GroupName, newDeviceGroup.Device);
		resetNewDeviceGroup();
	};

	$scope.removeDeviceFromGroup = function (groupName, device) {
		if (confirm("Are you sure you want to remove " + device.Name + " from " + groupName))
			deviceService.RemoveDeviceFromGroup(groupName, device);
	};

	Object.defineProperty($scope, "deviceCount", {
		get: function () {
			return Object.keys($scope.devices).length;
		}
	});

	Object.defineProperty($scope, "groupCount", {
		get: function () {
			return Object.keys($scope.groups).length;
		}
	});

	Object.defineProperty($scope, "devicesInGroups", {
		get: function () {
			var yes = false;
			angular.forEach($scope.groups, function (group) {
				if (group.length > 0)
					yes = true;
			});
			return yes;
		}
	});

	resetDevice();
	resetGroupName();
	resetNewDeviceGroup();
}]);
