﻿app.service("triggerService", ["webApiService", function (webApiService) {
	var self = this;
	self.triggers = [];

	webApiService.registerCallbackService(self);

	self.UpdateTriggers = function (triggers) {
		self.triggers = triggers;
		angular.forEach(self.triggers, function (trigger) {
			Object.defineProperty(trigger, "IsEnabled", {
				get: function () {
					return trigger.Enabled;
				},
				set: function (newValue) {
					trigger.Enabled = newValue;
					webApiService.EnableTrigger(trigger.Id, trigger.Enabled);
				}
			});
		});
	};

	self.AddTrigger = function (trigger) {
		webApiService.AddTrigger(trigger);
	};

	self.DeleteTrigger = function (trigger) {
		webApiService.DeleteTrigger(trigger.Id);
	};

	self.ReloadTriggers = function () {
		webApiService.ReloadTriggers();
	};
}]);