import React from 'react';
import './menu.scss'
import { Link } from "react-router-dom";

export default class Menu extends React.Component {
	constructor(props) {
		super(props);

		this.state = {
			open: props.open || false
		};
	}

	close() {
		this.setState({ open: false });
	}

	toggle() {
		this.setState({ open: !this.state.open });
	}

	render() {
		return (
			<>
				<div className={`overlay ${this.state.open ? "show" : ""}`} onClick={this.close.bind(this)}></div>
				<nav className={`navigation ${this.state.open ? "visible" : ""}`}>
					<Link className="link" to="/" onClick={this.close.bind(this)}>Home</Link>
					<Link className="link" to="/devices" onClick={this.close.bind(this)}>Devices</Link>
					<Link className="link" to="/triggers" onClick={this.close.bind(this)}>Triggers</Link>
					<Link className="link" to="/settings" onClick={this.close.bind(this)}>Settings</Link>
				</nav>
			</>
		)
	}
}